Index: lemon/edge_set.h
===================================================================
--- lemon/edge_set.h	(revision 1962)
+++ lemon/edge_set.h	(revision 1979)
@@ -20,11 +20,6 @@
 #define LEMON_EDGE_SET_H
 
-#include <lemon/bits/erasable_graph_extender.h>
-#include <lemon/bits/clearable_graph_extender.h>
-#include <lemon/bits/extendable_graph_extender.h>
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/default_map.h>
-#include <lemon/bits/graph_extender.h>
+
+#include <lemon/bits/edge_set_extender.h>
 
 /// \ingroup graphs
@@ -230,24 +225,9 @@
   /// \ref concept::ErasableGraph "ErasableGraph" concept.
   template <typename _Graph>
-  class ListEdgeSet :
-    public ErasableEdgeSetExtender<
-    ClearableEdgeSetExtender<
-    ExtendableEdgeSetExtender<
-    MappableEdgeSetExtender<
-    IterableGraphExtender<
-    AlterableEdgeSetExtender<
-    GraphExtender<
-    ListEdgeSetBase<_Graph> > > > > > > > {
-
-  public:
-
-    typedef ErasableEdgeSetExtender<
-      ClearableEdgeSetExtender<
-      ExtendableEdgeSetExtender<
-      MappableEdgeSetExtender<
-      IterableGraphExtender<
-      AlterableEdgeSetExtender<
-      GraphExtender<
-      ListEdgeSetBase<_Graph> > > > > > > > Parent;
+  class ListEdgeSet : public EdgeSetExtender<ListEdgeSetBase<_Graph> > {
+
+  public:
+
+    typedef EdgeSetExtender<ListEdgeSetBase<_Graph> > Parent;
     
     typedef typename Parent::Node Node;
@@ -337,24 +317,11 @@
   /// \ref concept::ErasableUGraph "ErasableUGraph" concept.
   template <typename _Graph>
-  class ListUEdgeSet :
-    public ErasableUEdgeSetExtender<
-    ClearableUEdgeSetExtender<
-    ExtendableUEdgeSetExtender<
-    MappableUEdgeSetExtender<
-    IterableUGraphExtender<
-    AlterableUEdgeSetExtender<
-    UGraphExtender<
-    ListEdgeSetBase<_Graph> > > > > > > > {
-
-  public:
-
-    typedef ErasableUEdgeSetExtender<
-      ClearableUEdgeSetExtender<
-      ExtendableUEdgeSetExtender<
-      MappableUEdgeSetExtender<
-      IterableUGraphExtender<
-      AlterableUEdgeSetExtender<
-      UGraphExtender<
-      ListEdgeSetBase<_Graph> > > > > > > > Parent;
+  class ListUEdgeSet 
+    : public UEdgeSetExtender<UGraphBaseExtender<ListEdgeSetBase<_Graph> > > {
+
+  public:
+
+    typedef UEdgeSetExtender<UGraphBaseExtender<
+      ListEdgeSetBase<_Graph> > > Parent;
     
     typedef typename Parent::Node Node;
@@ -568,22 +535,9 @@
   /// \ref concept::ExtendableGraph "ExtendableGraph" concept.
   template <typename _Graph>
-  class SmartEdgeSet :
-    public ClearableEdgeSetExtender<
-    ExtendableEdgeSetExtender<
-    MappableEdgeSetExtender<
-    IterableGraphExtender<
-    AlterableEdgeSetExtender<
-    GraphExtender<
-    SmartEdgeSetBase<_Graph> > > > > > > {
-
-  public:
-
-    typedef ClearableEdgeSetExtender<
-      ExtendableEdgeSetExtender<
-      MappableEdgeSetExtender<
-      IterableGraphExtender<
-      AlterableEdgeSetExtender<
-      GraphExtender<
-      SmartEdgeSetBase<_Graph> > > > > > > Parent;
+  class SmartEdgeSet : public EdgeSetExtender<SmartEdgeSetBase<_Graph> > {
+
+  public:
+
+    typedef EdgeSetExtender<SmartEdgeSetBase<_Graph> > Parent;
     
     typedef typename Parent::Node Node;
@@ -672,22 +626,11 @@
   /// \ref concept::ExtendableUGraph "ExtendableUGraph" concept.
   template <typename _Graph>
-  class SmartUEdgeSet :
-    public ClearableUEdgeSetExtender<
-    ExtendableUEdgeSetExtender<
-    MappableUEdgeSetExtender<
-    IterableUGraphExtender<
-    AlterableUEdgeSetExtender<
-    UGraphExtender<
-    SmartEdgeSetBase<_Graph> > > > > > > {
-
-  public:
-
-    typedef ClearableUEdgeSetExtender<
-      ExtendableUEdgeSetExtender<
-      MappableUEdgeSetExtender<
-      IterableUGraphExtender<
-      AlterableUEdgeSetExtender<
-      UGraphExtender<
-      SmartEdgeSetBase<_Graph> > > > > > > Parent;
+  class SmartUEdgeSet 
+    : public UEdgeSetExtender<UGraphBaseExtender<SmartEdgeSetBase<_Graph> > > {
+
+  public:
+
+    typedef UEdgeSetExtender<UGraphBaseExtender<
+      SmartEdgeSetBase<_Graph> > > Parent;
     
     typedef typename Parent::Node Node;
Index: lemon/euler.h
===================================================================
--- lemon/euler.h	(revision 1970)
+++ lemon/euler.h	(revision 1979)
@@ -234,5 +234,5 @@
   bool
 #else
-  typename enable_if<typename Graph::UTag,bool>::type
+  typename enable_if<UndirectedTagIndicator<Graph>,bool>::type
   euler(const Graph &g) 
   {
@@ -242,5 +242,5 @@
   }
   template<class Graph>
-  typename disable_if<typename Graph::UTag,bool>::type
+  typename disable_if<UndirectedTagIndicator<Graph>,bool>::type
 #endif
   euler(const Graph &g) 
Index: lemon/fredman_tarjan.h
===================================================================
--- lemon/fredman_tarjan.h	(revision 1956)
+++ lemon/fredman_tarjan.h	(revision 1979)
@@ -505,5 +505,5 @@
     ft.treeMap(tree);
     ft.run();
-  };
+  }
 
 } //END OF NAMESPACE LEMON
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1956)
+++ lemon/full_graph.h	(revision 1979)
@@ -23,8 +23,6 @@
 
 
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/static_map.h>
 #include <lemon/bits/graph_extender.h>
+
 
 #include <lemon/invalid.h>
@@ -192,8 +190,5 @@
   };
 
-  typedef StaticMappableGraphExtender<
-    IterableGraphExtender<
-    AlterableGraphExtender<
-    GraphExtender<FullGraphBase> > > > ExtendedFullGraphBase;
+  typedef GraphExtender<FullGraphBase> ExtendedFullGraphBase;
 
   /// \ingroup graphs
@@ -212,5 +207,19 @@
   public:
 
+    typedef ExtendedFullGraphBase Parent;
+
+    /// \brief Constructor
+    ///
     FullGraph(int n) { construct(n); }
+
+    /// \brief Resize the graph
+    ///
+    void resize(int n) {
+      Parent::getNotifier(Edge()).clear();
+      Parent::getNotifier(Node()).clear();
+      construct(n);
+      Parent::getNotifier(Node()).build();
+      Parent::getNotifier(Edge()).build();
+    }
   };
 
@@ -380,8 +389,6 @@
   };
 
-  typedef StaticMappableUGraphExtender<
-    IterableUGraphExtender<
-    AlterableUGraphExtender<
-    UGraphExtender<FullUGraphBase> > > > ExtendedFullUGraphBase;
+  typedef UGraphExtender<UGraphBaseExtender<FullUGraphBase> > 
+  ExtendedFullUGraphBase;
 
   /// \ingroup graphs
@@ -402,5 +409,21 @@
   class FullUGraph : public ExtendedFullUGraphBase {
   public:
+
+    typedef ExtendedFullUGraphBase Parent;
+
+    /// \brief Constructor
     FullUGraph(int n) { construct(n); }
+
+    /// \brief Resize the graph
+    ///
+    void resize(int n) {
+      Parent::getNotifier(Edge()).clear();
+      Parent::getNotifier(UEdge()).clear();
+      Parent::getNotifier(Node()).clear();
+      construct(n);
+      Parent::getNotifier(Node()).build();
+      Parent::getNotifier(UEdge()).build();
+      Parent::getNotifier(Edge()).build();
+    }
   };
 
@@ -578,10 +601,6 @@
 
 
-  typedef StaticMappableBpUGraphExtender<
-    IterableBpUGraphExtender<
-    AlterableBpUGraphExtender<
-    BpUGraphExtender <
-    FullBpUGraphBase> > > >
-  ExtendedFullBpUGraphBase;
+  typedef BpUGraphExtender< BpUGraphBaseExtender<
+    FullBpUGraphBase> > ExtendedFullBpUGraphBase;
 
 
@@ -600,8 +619,21 @@
     public ExtendedFullBpUGraphBase {
   public:
+
     typedef ExtendedFullBpUGraphBase Parent;
+
     FullBpUGraph(int aNodeNum, int bNodeNum) {
       Parent::construct(aNodeNum, bNodeNum);
     }
+    /// \brief Resize the graph
+    ///
+    void resize(int n, int m) {
+      Parent::getNotifier(Edge()).clear();
+      Parent::getNotifier(UEdge()).clear();
+      Parent::getNotifier(Node()).clear();
+      construct(n, m);
+      Parent::getNotifier(Node()).build();
+      Parent::getNotifier(UEdge()).build();
+      Parent::getNotifier(Edge()).build();
+    }
   };
 
Index: lemon/graph_adaptor.h
===================================================================
--- lemon/graph_adaptor.h	(revision 1957)
+++ lemon/graph_adaptor.h	(revision 1979)
@@ -30,11 +30,8 @@
 #include <lemon/invalid.h>
 #include <lemon/maps.h>
-#include <lemon/bits/erasable_graph_extender.h>
-#include <lemon/bits/clearable_graph_extender.h>
-#include <lemon/bits/extendable_graph_extender.h>
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/default_map.h>
+
+#include <lemon/bits/graph_adaptor_extender.h>
 #include <lemon/bits/graph_extender.h>
+
 #include <iostream>
 
@@ -118,8 +115,4 @@
     int id(const Edge& e) const { return graph->id(e); }
     
-    Edge oppositeNode(const Edge& e) const { 
-      return Edge(graph->opposite(e)); 
-    }
-
     template <typename _Value>
     class NodeMap : public _Graph::template NodeMap<_Value> {
@@ -146,8 +139,8 @@
   template <typename _Graph>
   class GraphAdaptor :
-    public IterableGraphExtender<GraphAdaptorBase<_Graph> > { 
+    public GraphAdaptorExtender<GraphAdaptorBase<_Graph> > { 
   public:
     typedef _Graph Graph;
-    typedef IterableGraphExtender<GraphAdaptorBase<_Graph> > Parent;
+    typedef GraphAdaptorExtender<GraphAdaptorBase<_Graph> > Parent;
   protected:
     GraphAdaptor() : Parent() { }
@@ -199,8 +192,8 @@
   template<typename _Graph>
   class RevGraphAdaptor : 
-    public IterableGraphExtender<RevGraphAdaptorBase<_Graph> > {
+    public GraphAdaptorExtender<RevGraphAdaptorBase<_Graph> > {
   public:
     typedef _Graph Graph;
-    typedef IterableGraphExtender<
+    typedef GraphAdaptorExtender<
       RevGraphAdaptorBase<_Graph> > Parent;
   protected:
@@ -323,4 +316,5 @@
     bool hidden(const Edge& e) const { return !(*edge_filter_map)[e]; }
 
+    typedef False FindEdgeTag;
     typedef False NodeNumTag;
     typedef False EdgeNumTag;
@@ -429,4 +423,5 @@
     bool hidden(const Edge& e) const { return !(*edge_filter_map)[e]; }
 
+    typedef False FindEdgeTag;
     typedef False NodeNumTag;
     typedef False EdgeNumTag;
@@ -497,9 +492,9 @@
 	   typename EdgeFilterMap, bool checked = true>
   class SubGraphAdaptor : 
-    public IterableGraphExtender<
+    public GraphAdaptorExtender<
     SubGraphAdaptorBase<_Graph, NodeFilterMap, EdgeFilterMap, checked> > {
   public:
     typedef _Graph Graph;
-    typedef IterableGraphExtender<
+    typedef GraphAdaptorExtender<
       SubGraphAdaptorBase<_Graph, NodeFilterMap, EdgeFilterMap> > Parent;
   protected:
@@ -704,11 +699,11 @@
 
   template <typename _Graph>
-  class UGraphAdaptorBase : 
-    public UGraphExtender<GraphAdaptorBase<_Graph> > {
+  class UndirectGraphAdaptorBase : 
+    public UGraphBaseExtender<GraphAdaptorBase<_Graph> > {
   public:
     typedef _Graph Graph;
-    typedef UGraphExtender<GraphAdaptorBase<_Graph> > Parent;
+    typedef UGraphBaseExtender<GraphAdaptorBase<_Graph> > Parent;
   protected:
-    UGraphAdaptorBase() : Parent() { }
+    UndirectGraphAdaptorBase() : Parent() { }
   public:
     typedef typename Parent::UEdge UEdge;
@@ -718,5 +713,5 @@
     class EdgeMap {
     protected:
-      const UGraphAdaptorBase<_Graph>* g;
+      const UndirectGraphAdaptorBase<_Graph>* g;
       template <typename TT> friend class EdgeMap;
       typename _Graph::template EdgeMap<T> forward_map, backward_map; 
@@ -725,8 +720,8 @@
       typedef Edge Key;
       
-      EdgeMap(const UGraphAdaptorBase<_Graph>& _g) : g(&_g), 
+      EdgeMap(const UndirectGraphAdaptorBase<_Graph>& _g) : g(&_g), 
 	forward_map(*(g->graph)), backward_map(*(g->graph)) { }
 
-      EdgeMap(const UGraphAdaptorBase<_Graph>& _g, T a) : g(&_g), 
+      EdgeMap(const UndirectGraphAdaptorBase<_Graph>& _g, T a) : g(&_g), 
 	forward_map(*(g->graph), a), backward_map(*(g->graph), a) { }
       
@@ -754,8 +749,8 @@
       typedef UEdge Key;
       
-      UEdgeMap(const UGraphAdaptorBase<_Graph>& g) : 
+      UEdgeMap(const UndirectGraphAdaptorBase<_Graph>& g) : 
 	map(*(g.graph)) { }
 
-      UEdgeMap(const UGraphAdaptorBase<_Graph>& g, T a) : 
+      UEdgeMap(const UndirectGraphAdaptorBase<_Graph>& g, T a) : 
 	map(*(g.graph), a) { }
       
@@ -779,15 +774,15 @@
   /// \author Marton Makai
   template<typename _Graph>
-  class UGraphAdaptor : 
-    public IterableUGraphExtender<
-    UGraphAdaptorBase<_Graph> > {
+  class UndirectGraphAdaptor : 
+    public UGraphAdaptorExtender<
+    UndirectGraphAdaptorBase<_Graph> > {
   public:
     typedef _Graph Graph;
-    typedef IterableUGraphExtender<
-      UGraphAdaptorBase<_Graph> > Parent;
+    typedef UGraphAdaptorExtender<
+      UndirectGraphAdaptorBase<_Graph> > Parent;
   protected:
-    UGraphAdaptor() { }
-  public:
-    UGraphAdaptor(_Graph& _graph) { 
+    UndirectGraphAdaptor() { }
+  public:
+    UndirectGraphAdaptor(_Graph& _graph) { 
       setGraph(_graph);
     }
@@ -1084,9 +1079,9 @@
 	   typename ForwardFilterMap, typename BackwardFilterMap>
   class SubBidirGraphAdaptor : 
-    public IterableGraphExtender<
+    public GraphAdaptorExtender<
     SubBidirGraphAdaptorBase<_Graph, ForwardFilterMap, BackwardFilterMap> > {
   public:
     typedef _Graph Graph;
-    typedef IterableGraphExtender<
+    typedef GraphAdaptorExtender<
       SubBidirGraphAdaptorBase<
       _Graph, ForwardFilterMap, BackwardFilterMap> > Parent;
@@ -1342,9 +1337,9 @@
   template <typename _Graph, typename FirstOutEdgesMap>
   class ErasingFirstGraphAdaptor : 
-    public IterableGraphExtender<
+    public GraphAdaptorExtender<
     ErasingFirstGraphAdaptorBase<_Graph, FirstOutEdgesMap> > {
   public:
     typedef _Graph Graph;
-    typedef IterableGraphExtender<
+    typedef GraphAdaptorExtender<
       ErasingFirstGraphAdaptorBase<_Graph, FirstOutEdgesMap> > Parent;
     ErasingFirstGraphAdaptor(Graph& _graph, 
@@ -1712,7 +1707,7 @@
   template <typename _Graph>
   class SplitGraphAdaptor 
-    : public IterableGraphExtender<SplitGraphAdaptorBase<_Graph> > {
-  public:
-    typedef IterableGraphExtender<SplitGraphAdaptorBase<_Graph> > Parent;
+    : public GraphAdaptorExtender<SplitGraphAdaptorBase<_Graph> > {
+  public:
+    typedef GraphAdaptorExtender<SplitGraphAdaptorBase<_Graph> > Parent;
 
     SplitGraphAdaptor(_Graph& graph) {
Index: lemon/grid_ugraph.h
===================================================================
--- lemon/grid_ugraph.h	(revision 1979)
+++ lemon/grid_ugraph.h	(revision 1979)
@@ -0,0 +1,536 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef GRID_UGRAPH_H
+#define GRID_UGRAPH_H
+
+#include <iostream>
+#include <lemon/invalid.h>
+#include <lemon/utility.h>
+
+#include <lemon/bits/graph_extender.h>
+
+#include <lemon/xy.h>
+
+///\ingroup graphs
+///\file
+///\brief GridUGraph class.
+
+namespace lemon {
+
+  /// \brief Base graph for GridUGraph.
+  ///
+  /// Base graph for grid graph. It describes some member functions
+  /// which can be used in the GridUGraph.
+  ///
+  /// \warning Always use the GridUGraph instead of this.
+  /// \see GridUGraph
+  class GridUGraphBase {
+
+  public:
+
+    typedef GridUGraphBase UGraph;
+
+    class Node;
+    class Edge;
+
+  public:
+
+    GridUGraphBase() {}
+
+  protected:
+
+    /// \brief Creates a grid graph with the given size.
+    ///
+    /// Creates a grid graph with the given size.
+    void construct(int width, int height) {
+      _height = height; _width = width;
+      _nodeNum = height * width; _edgeNum = 2 * _nodeNum - width - height;
+      _edgeLimit = _nodeNum - width;
+    }
+
+    /// \brief Gives back the edge goes down from the node.
+    ///
+    /// Gives back the edge goes down from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge _down(Node n) const {
+      if (n.id < _nodeNum - _width) {
+	return Edge(n.id);
+      } else {
+	return INVALID;
+      }
+    }
+
+    /// \brief Gives back the edge comes from up into the node.
+    ///
+    /// Gives back the edge comes from up into the node. If there is not
+    /// incoming edge then it gives back INVALID.
+    Edge _up(Node n) const {
+      if (n.id >= _width) {
+	return Edge(n.id - _width);
+      } else {
+	return INVALID;
+      }
+    }
+
+    /// \brief Gives back the edge goes right from the node.
+    ///
+    /// Gives back the edge goes right from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge _right(Node n) const {
+      if (n.id % _width < _width - 1) {
+	return _edgeLimit + n.id % _width + (n.id / _width) * (_width - 1);
+      } else {
+	return INVALID;
+      }
+    }
+
+    /// \brief Gives back the edge comes from left into the node.
+    ///
+    /// Gives back the edge comes left up into the node. If there is not
+    /// incoming edge then it gives back INVALID.
+    Edge _left(Node n) const {
+      if (n.id % _width > 0) {
+	return _edgeLimit + n.id % _width + (n.id / _width) * (_width - 1) - 1;
+      } else {
+	return INVALID;
+      }
+    }
+
+  public:
+
+    class IndexError : public RuntimeError {
+    public:
+      virtual const char* exceptionName() const {
+        return "lemon::GridUGraph::IndexError";
+      }  
+    };
+
+    
+    /// \brief The node on the given position.
+    /// 
+    /// Gives back the node on the given position.
+    Node operator()(int i, int j) const {
+      LEMON_ASSERT(0 <= i && i < width() && 0 <= j  && j < height(), IndexError());
+      return Node(i + j * _width);
+    }
+
+    /// \brief Gives back the row index of the node.
+    ///
+    /// Gives back the row index of the node.
+    int row(Node n) const {
+      return n.id / _width;
+    }
+    
+    /// \brief Gives back the coloumn index of the node.
+    ///
+    /// Gives back the coloumn index of the node.
+    int col(Node n) const {
+      return n.id % _width;    
+    }
+
+    /// \brief Gives back the width of the graph.
+    ///
+    /// Gives back the width of the graph.
+    int width() const {
+      return _width;
+    }
+
+    /// \brief Gives back the height of the graph.
+    ///
+    /// Gives back the height of the graph.
+    int height() const {
+      return _height;
+    }
+
+    typedef True NodeNumTag;
+    typedef True EdgeNumTag;
+
+    ///Number of nodes.
+    int nodeNum() const { return _nodeNum; }
+    ///Number of edges.
+    int edgeNum() const { return _edgeNum; }
+
+    /// Maximum node ID.
+    
+    /// Maximum node ID.
+    ///\sa id(Node)
+    int maxNodeId() const { return nodeNum() - 1; }
+    /// Maximum edge ID.
+    
+    /// Maximum edge ID.
+    ///\sa id(Edge)
+    int maxEdgeId() const { return edgeNum() - 1; }
+
+    /// \brief Gives back the source node of an edge.
+    ///    
+    /// Gives back the source node of an edge.
+    Node source(Edge e) const {
+      if (e.id < _edgeLimit) {
+	return e.id;
+      } else {
+	return (e.id - _edgeLimit) % (_width - 1) +
+	  (e.id - _edgeLimit) / (_width - 1) * _width;
+      }
+    }
+
+    /// \brief Gives back the target node of an edge.
+    ///    
+    /// Gives back the target node of an edge.
+    Node target(Edge e) const {
+      if (e.id < _edgeLimit) {
+	return e.id + _width;
+      } else {
+	return (e.id - _edgeLimit) % (_width - 1) +
+	  (e.id - _edgeLimit) / (_width - 1) * _width + 1;
+      }
+    }
+
+    /// Node ID.
+    
+    /// The ID of a valid Node is a nonnegative integer not greater than
+    /// \ref maxNodeId(). The range of the ID's is not surely continuous
+    /// and the greatest node ID can be actually less then \ref maxNodeId().
+    ///
+    /// The ID of the \ref INVALID node is -1.
+    ///\return The ID of the node \c v. 
+
+    static int id(Node v) { return v.id; }
+    /// Edge ID.
+    
+    /// The ID of a valid Edge is a nonnegative integer not greater than
+    /// \ref maxEdgeId(). The range of the ID's is not surely continuous
+    /// and the greatest edge ID can be actually less then \ref maxEdgeId().
+    ///
+    /// The ID of the \ref INVALID edge is -1.
+    ///\return The ID of the edge \c e. 
+    static int id(Edge e) { return e.id; }
+
+    static Node nodeFromId(int id) { return Node(id);}
+    
+    static Edge edgeFromId(int id) { return Edge(id);}
+
+    typedef True FindEdgeTag;
+
+    /// Finds an edge between two nodes.
+    
+    /// Finds an edge from node \c u to node \c v.
+    ///
+    /// If \c prev is \ref INVALID (this is the default value), then
+    /// It finds the first edge from \c u to \c v. Otherwise it looks for
+    /// the next edge from \c u to \c v after \c prev.
+    /// \return The found edge or INVALID if there is no such an edge.
+    Edge findEdge(Node u, Node v, Edge prev = INVALID) const {
+      if (prev != INVALID) return INVALID;
+      if (v.id - u.id == _width) return Edge(u.id);
+      if (v.id - u.id == 1 && u.id % _width < _width - 1) {
+	return Edge(u.id / _width * (_width - 1) +
+		    u.id % _width + _edgeLimit);
+      }
+      return INVALID;
+    }
+    
+      
+    class Node {
+      friend class GridUGraphBase;
+
+    protected:
+      int id;
+      Node(int _id) { id = _id;}
+    public:
+      Node() {}
+      Node (Invalid) { id = -1; }
+      bool operator==(const Node node) const {return id == node.id;}
+      bool operator!=(const Node node) const {return id != node.id;}
+      bool operator<(const Node node) const {return id < node.id;}
+    };
+    
+
+
+    class Edge {
+      friend class GridUGraphBase;
+      
+    protected:
+      int id; 
+
+      Edge(int _id) : id(_id) {}
+
+    public:
+      Edge() { }
+      Edge (Invalid) { id = -1; }
+      bool operator==(const Edge edge) const {return id == edge.id;}
+      bool operator!=(const Edge edge) const {return id != edge.id;}
+      bool operator<(const Edge edge) const {return id < edge.id;}
+    };
+
+    void first(Node& node) const {
+      node.id = nodeNum() - 1;
+    }
+
+    static void next(Node& node) {
+      --node.id;
+    }
+
+    void first(Edge& edge) const {
+      edge.id = edgeNum() - 1;
+    }
+
+    static void next(Edge& edge) {
+      --edge.id;
+    }
+
+    void firstOut(Edge& edge, const Node& node) const {
+      if (node.id < _nodeNum - _width) {
+	edge.id = node.id;
+      } else if (node.id % _width < _width - 1) {
+	edge.id = _edgeLimit + node.id % _width +
+	  (node.id / _width) * (_width - 1);
+      } else {
+	edge.id = -1;
+      }
+    }
+
+    void nextOut(Edge& edge) const {
+      if (edge.id >= _edgeLimit) {
+	edge.id = -1;
+      } else if (edge.id % _width < _width - 1) {
+	edge.id = _edgeLimit + edge.id % _width +
+	  (edge.id / _width) * (_width - 1);
+      } else {
+	edge.id = -1;
+      }
+    }
+
+    void firstIn(Edge& edge, const Node& node) const {
+      if (node.id >= _width) {
+	edge.id = node.id - _width;
+      } else if (node.id % _width > 0) {
+	edge.id = _edgeLimit + node.id % _width +
+	  (node.id / _width) * (_width - 1) - 1;
+      } else {
+	edge.id = -1;
+      }
+    }
+    
+    void nextIn(Edge& edge) const {
+      if (edge.id >= _edgeLimit) {
+	edge.id = -1;
+      } else if (edge.id % _width > 0) {
+	edge.id = _edgeLimit + edge.id % _width +
+	  (edge.id / _width + 1) * (_width - 1) - 1;
+      } else {
+	edge.id = -1;
+      }
+    }
+
+  private:
+    int _width, _height;
+    int _nodeNum, _edgeNum;
+    int _edgeLimit;
+  };
+
+
+  typedef UGraphExtender<UGraphBaseExtender<
+    GridUGraphBase> > ExtendedGridUGraphBase;
+
+  /// \ingroup graphs
+  ///
+  /// \brief Grid graph class
+  ///
+  /// This class implements a special graph type. The nodes of the
+  /// graph can be indiced by two integer \c (i,j) value where \c i
+  /// is in the \c [0,width) range and j is in the [0, height) range.
+  /// Two nodes are connected in the graph if the indices differ only
+  /// on one position and only one is the difference. 
+  ///
+  /// The graph can be indiced in the following way:
+  ///\code
+  /// GridUGraph graph(w, h);
+  /// GridUGraph::NodeMap<int> val(graph); 
+  /// for (int i = 0; i < graph.width(); ++i) {
+  ///   for (int j = 0; j < graph.height(); ++j) {
+  ///     val[graph(i, j)] = i + j;
+  ///   }
+  /// }
+  ///\endcode
+  ///
+  /// The graph type is fully conform to the \ref concept::UUGraph
+  /// "Undirected UGraph" concept.
+  ///
+  /// \author Balazs Dezso
+  /// \see GridUGraphBase
+  class GridUGraph : public ExtendedGridUGraphBase {
+  public:
+
+    typedef ExtendedGridUGraphBase Parent;
+
+    /// \brief Map to get the indices of the nodes as xy<int>.
+    ///
+    /// Map to get the indices of the nodes as xy<int>.
+    class IndexMap {
+    public:
+      /// \brief The key type of the map
+      typedef GridUGraph::Node Key;
+      /// \brief The value type of the map
+      typedef xy<int> Value;
+
+      /// \brief Constructor
+      ///
+      /// Constructor
+      IndexMap(const GridUGraph& _graph) : graph(_graph) {}
+
+      /// \brief The subscript operator
+      ///
+      /// The subscript operator.
+      Value operator[](Key key) const {
+	return xy<int>(graph.row(key), graph.col(key));
+      }
+
+    private:
+      const GridUGraph& graph;
+    };
+
+    /// \brief Map to get the row of the nodes.
+    ///
+    /// Map to get the row of the nodes.
+    class RowMap {
+    public:
+      /// \brief The key type of the map
+      typedef GridUGraph::Node Key;
+      /// \brief The value type of the map
+      typedef int Value;
+
+      /// \brief Constructor
+      ///
+      /// Constructor
+      RowMap(const GridUGraph& _graph) : graph(_graph) {}
+
+      /// \brief The subscript operator
+      ///
+      /// The subscript operator.
+      Value operator[](Key key) const {
+	return graph.row(key);
+      }
+
+    private:
+      const GridUGraph& graph;
+    };
+
+    /// \brief Map to get the column of the nodes.
+    ///
+    /// Map to get the column of the nodes.
+    class ColMap {
+    public:
+      /// \brief The key type of the map
+      typedef GridUGraph::Node Key;
+      /// \brief The value type of the map
+      typedef int Value;
+
+      /// \brief Constructor
+      ///
+      /// Constructor
+      ColMap(const GridUGraph& _graph) : graph(_graph) {}
+
+      /// \brief The subscript operator
+      ///
+      /// The subscript operator.
+      Value operator[](Key key) const {
+	return graph.col(key);
+      }
+
+    private:
+      const GridUGraph& graph;
+    };
+
+    /// \brief Constructor
+    ///
+    /// 
+    GridUGraph(int n, int m) { construct(n, m); }
+
+    /// \brief Resize the graph
+    ///
+    void resize(int n, int m) {
+      Parent::getNotifier(Edge()).clear();
+      Parent::getNotifier(UEdge()).clear();
+      Parent::getNotifier(Node()).clear();
+      construct(n, m);
+      Parent::getNotifier(Node()).build();
+      Parent::getNotifier(UEdge()).build();
+      Parent::getNotifier(Edge()).build();
+    }
+    
+    /// \brief Gives back the edge goes down from the node.
+    ///
+    /// Gives back the edge goes down from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge down(Node n) const {
+      UEdge ue = _down(n);
+      return ue != INVALID ? direct(ue, true) : INVALID;
+    }
+    
+    /// \brief Gives back the edge goes up from the node.
+    ///
+    /// Gives back the edge goes up from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge up(Node n) const {
+      UEdge ue = _up(n);
+      return ue != INVALID ? direct(ue, false) : INVALID;
+    }
+
+    /// \brief Gives back the edge goes right from the node.
+    ///
+    /// Gives back the edge goes right from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge right(Node n) const {
+      UEdge ue = _right(n);
+      return ue != INVALID ? direct(ue, true) : INVALID;
+    }
+
+    /// \brief Gives back the edge goes left from the node.
+    ///
+    /// Gives back the edge goes left from the node. If there is not
+    /// outgoing edge then it gives back INVALID.
+    Edge left(Node n) const {
+      UEdge ue = _left(n);
+      return ue != INVALID ? direct(ue, false) : INVALID;
+    }
+    
+  };
+
+  /// \brief Index map of the grid graph
+  ///
+  /// Just returns an IndexMap for the grid graph.
+  GridUGraph::IndexMap indexMap(const GridUGraph& graph) {
+    return GridUGraph::IndexMap(graph);
+  }
+
+  /// \brief Row map of the grid graph
+  ///
+  /// Just returns a RowMap for the grid graph.
+  GridUGraph::RowMap rowMap(const GridUGraph& graph) {
+    return GridUGraph::RowMap(graph);
+  }
+
+  /// \brief Column map of the grid graph
+  ///
+  /// Just returns a ColMap for the grid graph.
+  GridUGraph::ColMap colMap(const GridUGraph& graph) {
+    return GridUGraph::ColMap(graph);
+  }
+}
+#endif
Index: lemon/hypercube_graph.h
===================================================================
--- lemon/hypercube_graph.h	(revision 1963)
+++ lemon/hypercube_graph.h	(revision 1979)
@@ -26,7 +26,4 @@
 #include <lemon/error.h>
 
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/static_map.h>
 #include <lemon/bits/graph_extender.h>
 
@@ -237,9 +234,5 @@
 
 
-  typedef StaticMappableGraphExtender<
-    IterableGraphExtender<
-    AlterableGraphExtender<
-    GraphExtender<
-    HyperCubeGraphBase> > > > ExtendedHyperCubeGraphBase;
+  typedef GraphExtender<HyperCubeGraphBase> ExtendedHyperCubeGraphBase;
 
   /// \ingroup graphs
Index: lemon/kruskal.h
===================================================================
--- lemon/kruskal.h	(revision 1956)
+++ lemon/kruskal.h	(revision 1979)
@@ -24,4 +24,5 @@
 #include <lemon/unionfind.h>
 #include <lemon/utility.h>
+#include <lemon/traits.h>
 
 /**
@@ -229,5 +230,5 @@
 
     template<class _GR>
-    typename enable_if<typename _GR::UTag,void>::type
+    typename enable_if<UndirectedTagIndicator<_GR>,void>::type
     fillWithEdges(const _GR& g, const Map& m,dummy<0> = 0) 
     {
@@ -237,5 +238,5 @@
 
     template<class _GR>
-    typename disable_if<typename _GR::UTag,void>::type
+    typename disable_if<UndirectedTagIndicator<_GR>,void>::type
     fillWithEdges(const _GR& g, const Map& m,dummy<1> = 1) 
     {
